#ifndef _ALLEGRO_DYNAMIC_FONT_INTERN_
#define _ALLEGRO_DYNAMIC_FONT_INTERN_

#include <allegro.h>
#include "splif2.h"

/*
 * the SPLINE_SHAPE struct describes one shape built from
 * a closed path of multiple b-splines
 */
typedef struct SPLINE_SHAPE
{
   int w;   /* width of the shape in pixels at scale 1 */
   int h;   /* height of the shape in pixels at scale 1 */
   int nr_splines;   /* number of b-splines */
   BITMAP *cached;
   int cached_color;

   /* must be last element of struct !!!!!!!!*/
   int data[ZERO_SIZE][8]; /* coordinates of spline control points 100=1 pixel at scale 1 */
} SPLINE_SHAPE;


typedef struct SPLINE_FONT_DATA
{
   int start;
   int end;
   SPLINE_SHAPE **glyphs;
   struct SPLINE_FONT_DATA *next_range;
} SPLINE_FONT_DATA;


/* shape drawing primitive, from splrend.c */
extern void draw_shape(BITMAP *onto, int x, int y, int color, double scale_x, double scale_y, SPLINE_SHAPE *s);
extern void draw_shape_outline(BITMAP *onto, int x, int y, int color,double scale_x, double scale_y, SPLINE_SHAPE *s);
/* other shape manipulation , from shape.c */
extern SPLINE_SHAPE *create_shape(int w, int h, int nr_of_splines);
extern void shape_add_spline(SPLINE_SHAPE *s, int index, int *controlpoints);
extern void destroy_shape(SPLINE_SHAPE *s);
extern void shape_translate(SPLINE_SHAPE *s, int x, int y);
extern void shape_scale(SPLINE_SHAPE *s, double sx, double sy);
extern void shape_delete_splines(SPLINE_SHAPE *s, int min, int max);
/* font handling (from font.c) */
extern FONT *create_dynamic_font(int base, int numchar);


#endif
