#include <math.h>
#include "splif2.h"


int main(int argc, char **argv)
{
   FONT *f;
   int h=1,l;
   int i;
   int white;
   BITMAP *buffer;
   
   allegro_init();
   install_keyboard();
   install_timer();
   set_color_depth(16);
   if(set_gfx_mode(GFX_SAFE, 640,480,0,0))
     exit(1);

   clear_to_color(screen, 1);
   generate_332_palette(desktop_palette);
   set_palette(desktop_palette);

   rgb_map = malloc(sizeof(RGB_MAP));

   create_rgb_table(rgb_map, desktop_palette, NULL);
   

   buffer = create_bitmap_ex(16, SCREEN_W,SCREEN_H);

   clear(buffer);

   f = splif_load_font("fonts/test.fnt");

   ASSERT(f);

   splif_setantialias(TRUE);

   for (i = 1;i<20;i++)
   {
       splif_setscale(i/3.5,i/3.5);
       textout(screen,f,"ABCDEFG",10,h,makecol(255,255,255));
       h+= text_height(f) + 1;
   }

   textout(screen,font,"scale test finished. press a key...", 10, SCREEN_H - text_height(font), makecol(255,0,0));

   readkey();

   clear(screen);

   splif_setscale(3,3);

   textout(screen,f,"ABCDEFG",10,10,makecol(255,255,255));

   line(screen,10,5,10+text_length(f,"ABCDEFG"),5, makecol(255,0,0));

   textout(screen,font,"text_length test finished. press a key...", 10, SCREEN_H - text_height(font), makecol(255,0,0));

   readkey();


   splif_setfill(FALSE);

   white = makecol(255,255,255);
   for (i=0;i<49;i++)
   {
      splif_setscale(10*cos(i/10.0)+11,10*cos(i/8.0)+11);
      l = text_length(f, "ABCDEF");
      h = text_height(f);
      clear(buffer);
      textout(buffer,f, "ABCDEF",(SCREEN_W-l)/2, (SCREEN_H-h)/2, white);
      blit(buffer, screen,0,0,0,0,SCREEN_W,SCREEN_H);
      rest(10);

   }
   splif_setfill(TRUE);
   clear(buffer);

   splif_setantialias(FALSE);
   textout(buffer,f, "ABCDEF",(SCREEN_W-l)/2, (SCREEN_H-h)/2, white);
   blit(buffer, screen,0,0,0,0,SCREEN_W,SCREEN_H);

   textout(screen,font,"outline scale test finished. press a key...", 10, SCREEN_H - text_height(font), makecol(255,0,0));


   readkey();
   clear(buffer);
   splif_setantialias(TRUE);
   textout(buffer,f, "ABCDEF",(SCREEN_W-l)/2, (SCREEN_H-h)/2, white);
   blit(buffer, screen,0,0,0,0,SCREEN_W,SCREEN_H);

   textout(screen,font,"antialias test finished. press a key...", 10, SCREEN_H - text_height(font), makecol(255,0,0));
   readkey();
   font = f;

   gui_bg_color = makecol(255,255,255);
   gui_fg_color = makecol(0,0,0);

   splif_setscale(2,2);
   alert("ABCDEFABCDEFABCDEF",NULL,NULL, "OK",NULL,13,0);
   
   return 0;
}
END_OF_MAIN();



/*
test shape
int main(int argc, char **argv)
{
   SPLINE_SHAPE *s;
   int i,j;
   
   int points[2][8] =
   {
      {  50, 250,  250, 1500 , 250,1500, 1500,1500},
      {  1500, 1500,  1500, 250 , 500,250, 50,250}
   };


   s = malloc(sizeof(SPLINE_SHAPE) + 2 * 8 * sizeof(int));

   s->w = 16;
   s->h = 16;
   s->nr_splines = 2;

   for (i = 0;i<2;i++)
   {
      for (j=0;j<8;j++)
      {
         s->data[i][j] = points[i][j];
      }
   }
   

   
   allegro_init();
   install_keyboard();
   set_gfx_mode(GFX_AUTODETECT, 640,480,0,0);
   set_palette(desktop_palette);
   clear(screen);


   draw_shape(screen,10,10,0,1,1,s);
   draw_shape(screen,26,10,0,2,2,s);
   draw_shape(screen,58,10,0,30,30,s);
   
   readkey();

   return 0;
}
END_OF_MAIN();
*/
